package org.mcvly.bitdemo.worker.client

import com.fasterxml.jackson.databind.ObjectMapper
import org.mcvly.bitdemo.worker.client.dto.Block
import org.mcvly.bitdemo.worker.service.BlockPublishService
import spock.lang.Specification

class BlockchainDataWebsocketClientSpec extends Specification {

    def mapper = new ObjectMapper()
    def publishService = Mock(BlockPublishService)
    def endpoint = "ws://localhost:8887"

    def client = new BlockchainDataWebsocketClient(mapper, publishService, endpoint)

    def "handle onMessage"() {
        when:
        client.onMessage(sampleMessage)

        then:
        1 * publishService.submitNewBlock({it.height == 514804 && it.time == 1521812741 } as Block)
    }

    def sampleMessage = """{
  "op" : "block",
  "x" : {
    "txIndexes" : [ 337998750, 337999644, 337998550, 337999326, 337999248, 337998345, 337998363, 337998416, 337998515, 337998673, 337998675, 337998677, 337998174, 337999663, 337998529, 337998348, 337998415, 337999598, 337998693, 337998631, 337998433, 337999251, 337999287, 337999239, 337998627, 337998182, 337998615, 337998353, 337998669, 337998159, 337998592, 337998635, 337998700, 337999674, 337999231, 337998714, 337998338, 337998652, 337999463, 337999436, 337998577, 337999443, 337998662, 337998751, 337998752, 337999625, 337999412, 337999708, 337998710, 337998424, 337999620, 337999325, 337998670, 337999697, 337998681, 337999686, 337999704, 337999679, 337998366, 337999693, 337999666, 337998705, 337998676, 337999258, 337998427, 337998717, 337999507, 337998304, 337999210, 337999626, 337999455, 337998620, 337998417, 337999377, 337998488, 337998640, 337998180, 337999342, 337998579, 337999421, 337999361, 337999558, 337999348, 337999649, 337999382, 337998463, 337998621, 337999221, 337999334, 337999352, 337999360, 337998619, 337999499, 337998618, 337998419, 337999617, 337999453, 337998460, 337998611, 337999671, 337999593, 337998537, 337998576, 337998612, 337998502, 337998616, 337999653, 337998422, 337998530, 337998387, 337998625, 337999688, 337998641, 337999354, 337999596, 337998181, 337998176, 337999457, 337999424, 337999600, 337998397, 337998647, 337998183, 337999219, 337999318, 337999271, 337999425, 337999418, 337999420, 337999402, 337999434, 337999224, 337999669, 337998151, 337998565, 337999645, 337998501, 337999454, 337998624, 337998663, 337999467, 337998453, 337998504, 337999379, 337998555, 337998684, 337998561, 337998342, 337999652, 337998395, 337999316, 337999371, 337998341, 337999614, 337998509, 337999283, 337998692, 337998601, 337998184, 337998605, 337998440, 337998660, 337999273, 337998511, 337999394, 337999448, 337998648, 337999706, 337999410, 337999341, 337999641, 337999539, 337999387, 337998643, 337999391, 337999403, 337999340, 337998672, 337998549, 337999597, 337999640, 337998642, 337998683, 337998413, 337999462, 337998623, 337998451, 337998448, 337998653, 337999468, 337999397, 337998410, 337999245, 337999347, 337999445, 337998532, 337999234, 337999465, 337998567, 337998162, 337999590, 337998408, 337999235, 337999381, 337999329, 337999267, 337998386, 337998414, 337998143, 337999288, 337999398, 337998475, 337998485, 337998586, 337998169, 337998527, 337999534, 337999355, 337998753, 337999469, 337998585, 337999608, 337999651, 337999504, 337999579, 337998587, 337999274, 337999681, 337999506, 337999479, 337998637, 337999332, 337999385, 337999639, 337998521, 337998439, 337998391, 337998392, 337999351, 337998406, 337998498, 337999264, 337999363, 337999705, 337998492, 337998554, 337999694, 337998696, 337998711, 337999238, 337999390, 337999492, 337999335, 337998540, 337999636, 337999638, 337999444, 337998538, 337999595, 337999610, 337999336, 337999378, 337998360, 337999225, 337998441, 337999483, 337998496, 337998686, 337996380, 337998469, 337994716, 337998614, 337999560, 337998674, 337999441, 337999637, 337998170, 337998491, 337998665, 337999615, 337998646, 337999616, 337998630, 337998568, 337999672, 337999655, 337999466, 337999430, 337999343, 337998160, 337998362, 337999406, 337998401, 337998435, 337999368, 337999643, 337998343, 337998691, 337999481, 337998688, 337999370, 337998503, 337994756, 337999254, 337998476, 337999701, 337999618, 337999569, 337999474, 337999389, 337998376, 337999313, 337998698, 337998241, 337999520, 337998444, 337999571, 337999570, 337998350, 337999249, 337998518, 337998551, 337998651, 337998690, 337999349, 337998426, 337998713, 337998403, 337999312, 337998423, 337998385, 337998396, 337999609, 337998369, 337998526, 337998582, 337998606, 337998628, 337998558, 337999555, 337998388, 337999613, 337998442, 337999373, 337998514, 337999226, 337999218, 337999702, 337998694, 337998450, 337999711, 337999414, 337999540, 337999413, 337999572, 337999665, 337999589, 337998544, 337999563, 337998429, 337998506, 337999358, 337998536, 337999624, 337999587, 337999514, 337999578, 337999213, 337998510, 337998166, 337998050, 337998142, 337998152, 337998356, 337998371, 337999244, 337998389, 337999280, 337999323, 337999350, 337999435, 337998464, 337999562, 337999574, 337998589, 337999703, 337999683, 337999606, 337998447, 337998545, 337998584, 337999658, 337999646, 337998570, 337999331, 337998689, 337998697, 337994258, 337993352, 337993866, 337994268, 337993454, 337994294, 337993762, 337993834, 337993476, 337992619, 337993457, 337994349, 337993776, 337993766, 337993325, 337993832, 337994271, 337994368, 337993374, 337993763, 337994350, 337993828, 337994334, 337993331, 337994254, 337994319, 337992605, 337993410, 337993759, 337993860, 337993375, 337992608, 337994371, 337993467, 337992613, 337995077, 337994454, 337994692, 337995897, 337996181, 337996043, 337994278, 337993847, 337993795, 337993443, 337992607, 337993746, 337994234, 337992739, 337993774, 337993362, 337993732, 337993764, 337993987, 337993815, 337994613, 337994663, 337994534, 337996795, 337992630, 337993912, 337997530, 337995674, 337995972, 337996469, 337996792, 337996836, 337995214, 337994992, 337994556, 337995846, 337995678, 337996495, 337995505, 337995826, 337995103, 337996471, 337996121, 337994829, 337995690, 337995153, 337995918, 337997221, 337997202, 337995030, 337993971, 337995691, 337994376, 337993863, 337995087, 337992617, 337997188, 337995959, 337997037, 337997011, 337997004, 337996799, 337996803, 337997525, 337997531, 337994450, 337996825, 337996820, 337995008, 337996004, 337994515, 337994722, 337994688, 337993885, 337994734, 337996830, 337997019, 337996092, 337996853, 337997022, 337996843, 337996688, 337997529, 337996806, 337997003, 337997007, 337993436, 337995098, 337993366, 337995531, 337995799, 337995831, 337996326, 337995811, 337995641, 337995557, 337995058, 337993919, 337992981, 337997144, 337996494, 337995969, 337996409, 337996805, 337995938, 337995714, 337996145, 337995277, 337995832, 337993952, 337994448, 337994446, 337997325, 337996951, 337999440, 337995082, 337995292, 337998370, 337999503, 337998679, 337997505, 337994891, 337998459, 337999404, 337997046, 337998075, 337998534, 337997262, 337996398, 337994052, 337996377, 337995625, 337997988, 337996610, 337997191, 337998685, 337998373, 337998083, 337997994, 337998709, 337999678, 337997264, 337996672, 337997683, 337997730, 337996365, 337999259, 337993849, 337998297, 337999547, 337996344, 337997707, 337998552, 337999498, 337996873, 337998262, 337998661, 337997602, 337996311, 337996283, 337996531, 337996403, 337998333, 337997537, 337996180, 337999541, 337997346, 337998629, 337999568, 337999409, 337996758, 337999327, 337996555, 337996235, 337996938, 337996984, 337996604, 337997621, 337992686, 337998025, 337993596, 337998547, 337994491, 337994871, 337995644, 337996073, 337994255, 337994279, 337995308, 337995483, 337996313, 337997225, 337997305, 337996762, 337992880, 337993547, 337993579, 337998116, 337998457, 337999432, 337998626, 337999648, 337999661, 337999339, 337999364, 337999533, 337997155, 337994978, 337998364, 337993548, 337992549, 337992765, 337992527, 337993025, 337992602, 337992717, 337998528, 337994094, 337998505, 337994460, 337998452, 337999603, 337996265, 337998033, 337994578, 337992687, 337993468, 337992826, 337998067, 337992660, 337995882, 337997464, 337998535, 337995925, 337998678, 337994129, 337994972, 337994773, 337992558, 337996109, 337994953, 337997489, 337993339, 337999321, 337996107, 337997008, 337997519, 337993980, 337996683, 337994469, 337996640, 337996422, 337993474, 337995994, 337995339, 337997130, 337998649, 337999491, 337997060, 337997798, 337997808, 337995847, 337997409, 337999246, 337997886, 337997565, 337996165, 337995792, 337993922, 337995399, 337995009, 337997538, 337998215, 337996839, 337996833, 337995414, 337997832, 337999250, 337997940, 337995904, 337997744, 337997237, 337994744, 337995432, 337993690, 337999691, 337998306, 337997753, 337996009, 337996387, 337997177, 337996391, 337997179, 337996394, 337996393, 337996395, 337997769, 337994648, 337995430, 337996010, 337997309, 337999662, 337997658, 337995341, 337998574, 337996909, 337995686, 337994583, 337997797, 337996218, 337998508, 337998512, 337996905, 337998687, 337999549, 337999537, 337999543, 337995588, 337996091, 337997840, 337995257, 337999586, 337997893, 337994793, 337997771, 337996284, 337998591, 337997670, 337998420, 337997509, 337999592, 337997807, 337996770, 337997297, 337998012, 337997571, 337996598, 337999561, 337995078, 337998644, 337995293, 337995046, 337998519, 337999656, 337999594, 337995362, 337998068, 337997711, 337999257, 337998597, 337997702, 337998548, 337999399, 337995062, 337998438, 337999554, 337999216, 337998259, 337997078, 337999265, 337996644, 337996005, 337996343, 337998634, 337997132, 337997536, 337995253, 337997330, 337998596, 337993877, 337993892, 337995963, 337996306, 337996649, 337998200, 337997855, 337998557, 337995706, 337997829, 337997961, 337999508, 337997872, 337994889, 337999556, 337994882, 337995949, 337994925, 337996192, 337998609, 337995221, 337998575, 337999631, 337999461, 337998122, 337996080, 337996511, 337995979, 337998639, 337996971, 337993480, 337999566, 337995036, 337997420, 337998633, 337999601, 337998706, 337999261, 337998437, 337998495, 337999642, 337999599, 337999632, 337999458, 337999668, 337998400, 337998455, 337999437, 337999268, 337999416, 337999451, 337999623, 337999375, 337999438, 337998668, 337998500, 337999647, 337995735, 337998617, 337994835, 337995859, 337996226, 337995575, 337996046, 337995026, 337998666, 337999386, 337998517, 337999542, 337999660, 337995283, 337997201, 337996568, 337999544, 337999322, 337999495, 337995671, 337995711, 337999475, 337998250, 337995906, 337997524, 337997951, 337997708, 337996517, 337996784, 337996574, 337995759, 337996086, 337999470, 337995476, 337999362, 337999242, 337999388, 337998434, 337998602, 337998454, 337998671, 337998703, 337998564, 337999338, 337998578, 337998513, 337999253, 337998461, 337998581, 337999422, 337999460, 337999630, 337999429, 337999428, 337998531, 337999359, 337999482, 337999344, 337998493, 337998594, 337999553, 337999433, 337999260 ],
    "nTx" : 921,
    "totalBTCSent" : 864413540066,
    "estimatedBTCSent" : 80591753325,
    "reward" : 0,
    "size" : 1065835,
    "weight" : 3992413,
    "blockIndex" : 1683059,
    "prevBlockIndex" : 1684132,
    "height" : 514804,
    "hash" : "0000000000000000004c1bc335c1e009636a3994027f3be81ba436e5f6ef9fbd",
    "mrklRoot" : "fa59a23fe5b62765de8eb8249850165577e6d6421a9fb473f6e58d758c7d52e4",
    "version" : 536870912,
    "time" : 1521812741,
    "bits" : 391203401,
    "nonce" : 2725864130,
    "foundBy" : {
      "description" : "Unknown",
      "ip" : "127.0.0.1",
      "link" : "http://www.blockchain.info/tx/d1bf404c461d31e724ffbbb9b91b7682675b81ec58fd44fe8f69dfe4b1dffef4",
      "time" : 1521812741
    }
  }
}"""

}
